#include "Adafruit_ILI9341.h"
#include "Adafruit_GFX.h"
#include "XPT2046_Touchscreen.h"
#include "SPI.h"

#define TFT_DC 9
#define TFT_CS 10
#define TFT_RST 8
#define CS_PIN 7

#define BLACK 0x0000
#define BLUE 0x001F
#define RED 0xF800
#define GREEN 0x07E0
#define CYAN 0x07FF
#define MAGENTA 0xF81F
#define YELLOW 0xFFE0
#define WHITE 0xFFFF

/* --------------------------------- */
int16_t WIDTH;   // zainicjowanie zmiennej służącej nam do tworzenia przycisków
int16_t HEIGHT;  // zainicjowanie zmiennej służącej nam do tworzenia przycisków
/* --------------------------------- */

Adafruit_ILI9341 tft = Adafruit_ILI9341(TFT_CS, TFT_DC, TFT_RST);  //stworzenie obiektu obsługującego wyświetlacz
XPT2046_Touchscreen ts(CS_PIN);                                    // stworzenie obiektu pełniącego rolę ekranu dotykowego

void setup() {
  Serial.begin(9600);  // Rozpoczęcie transmisji szeregowej
  //do wyswietlacza
  pinMode(TFT_CS, OUTPUT);
  pinMode(CS_PIN, OUTPUT);
  digitalWrite(TFT_CS, HIGH);
  digitalWrite(CS_PIN, HIGH);

  tft.begin();              // Rozpoczęcie pracy ekranu
  tft.fillScreen(BLACK);    // Wypełnienie ekranu kolorem czarnym
  tft.setRotation(1);       // ustawienie rotacji ekranu na poziomą
  tft.setTextColor(WHITE);  // Ustawienie koloru tekstu na czarny

  ts.begin();         //rozpoczecie dzialania dotyku
  ts.setRotation(1);  //ustawienie polozenia ekranu

  //podział ekranu na 3 wiersze i 5 kolumn
  HEIGHT = tft.height() / 3;
  WIDTH = tft.width() / 5;

  //  tft.fillRect(WIDTH * 0, HEIGHT * 0, WIDTH, HEIGHT, RED);
  //  tft.fillRect(WIDTH * 1, HEIGHT * 0, WIDTH, HEIGHT, GREEN);
  //  tft.fillRect(WIDTH * 2, HEIGHT * 0, WIDTH, HEIGHT, MAGENTA);
  //  tft.fillRect(WIDTH * 3, HEIGHT * 0, WIDTH, HEIGHT, BLUE);
  //  tft.fillRect(WIDTH * 4, HEIGHT * 0, WIDTH, HEIGHT, YELLOW);

  //  tft.fillRect(WIDTH * 0, HEIGHT * 1, WIDTH, HEIGHT, YELLOW);
  //  tft.fillRect(WIDTH * 1, HEIGHT * 1, WIDTH, HEIGHT, MAGENTA);
  //  tft.fillRect(WIDTH * 2, HEIGHT * 1, WIDTH, HEIGHT, GREEN);
  //  tft.fillRect(WIDTH * 3, HEIGHT * 1, WIDTH, HEIGHT, GREEN);
  //  tft.fillRect(WIDTH * 4, HEIGHT * 1, WIDTH, HEIGHT, RED);
  //
  //  tft.fillRect(WIDTH * 0, HEIGHT * 2, WIDTH, HEIGHT, BLUE);
  //  tft.fillRect(WIDTH * 1, HEIGHT * 2, WIDTH, HEIGHT, WHITE);
  //  tft.fillRect(WIDTH * 2, HEIGHT * 2, WIDTH, HEIGHT, BLACK);
  //  tft.fillRect(WIDTH * 3, HEIGHT * 2, WIDTH, HEIGHT, RED);
  //  tft.fillRect(WIDTH * 4, HEIGHT * 2, WIDTH, HEIGHT, MAGENTA);

  tft.fillRect(WIDTH * 2, HEIGHT * 1, WIDTH, HEIGHT, GREEN);  //wyswietlenie zielonego prostokata
  tft.setTextSize(2);                                         //ustawienie rozmiaru tekstu
  tft.setTextColor(WHITE);                                    //ustawienie koloru tekstu
  tft.setCursor(WIDTH * 2.05, HEIGHT * 1.4);                  //ustawienie pozycji kursora
  tft.print("START");                                         //wyswietlenie tekstu na ekranie
}

bool sw = false;

void loop() {
  uint16_t xpos, ypos;          // inicjacja zmiennych służących do ustalenia składowych x i y pozycji kursora
  TS_Point tp = ts.getPoint();  // Stworzenie obiektu do ustalania aktualnego punktu na ekranie

  if (tp.z > 500) {                                // sprawdzanie czy punkt znajduje się w granicach ustalonych na początku programu
    xpos = map(tp.x, 3900, 150, 0, tft.height());  // rozdzielenie zmiennej tp na składową x poprzez funkcję mapowania
    ypos = map(tp.y, 150, 3700, 0, tft.width());   // rozdzielenie zmiennej tp na składową y poprzez funkcję mapowania
    if (ypos > 120 && ypos < 240) {
      if (xpos > 96 && xpos < 144) {
        if (sw) {                                                     //jeżeli sw jest równy prawda, to wykonaj poniższy kod
          tft.fillRect(WIDTH * 2, HEIGHT * 1, WIDTH, HEIGHT, GREEN);  //wyswietlenie zielonego prostokata
          tft.setTextSize(2);                                         //ustawienie rozmiaru tekstu
          tft.setTextColor(WHITE);                                    //ustawienie koloru tekstu
          tft.setCursor(WIDTH * 2.05, HEIGHT * 1.4);                  //ustawienie pozycji kursora
          tft.print("START");                                         //wyswietlenie tekstu na ekranie
          sw = false;                                                 //ustawienie zmeinnej sw na false
          Serial.println("Start");
        } else {                                                    //w przecwinym wypadku wykonaj ten pod else
          tft.fillRect(WIDTH * 2, HEIGHT * 1, WIDTH, HEIGHT, RED);  //wyswietlenie czerwonego prostokata
          tft.setTextSize(2);                                       //ustawienie rozmiaru tekstu
          tft.setTextColor(WHITE);                                  //ustawienie koloru tekstu
          tft.setCursor(WIDTH * 2.15, HEIGHT * 1.4);                //ustawienie pozycji kursora
          tft.print("STOP");                                        //wyswietlenie tekstu na ekranie
          sw = true;                                                //ustawienie zmiennej sw na true
          Serial.println("Start");
        }
        delay(500);  //opóźnienie
      }
    }
  }
}
